<%- include("partials/header") %>

    <div class="modal fade" id="editPasswordModal" tabindex="-1" role="dialog" aria-labelledby="editPasswordModalLabel" aria-hidden="true">
      <div class="modal-dialog" role="document">
        <div class="modal-content">
          <div class="modal-header border-0">
            <h5 class="modal-title" id="editPasswordModalLabel">تغییر پسوورد</h5>
            <button type="button" class="close mr-auto ml-0" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-body p-0">
            <form class="text-center login-form" onsubmit="editPassword(event);">
              <div class="form-group">
                <input type="password" class="form-control new-password-input text-center" placeholder="پسوورد جدید" onkeyup="clearConfirmPassword(event);">
              </div>
              <div class="form-group">
                <input type="password" class="form-control confirm-new-password-input text-center" placeholder="تکرار پسوورد" onkeyup="confirmPasswordCheck(event);">
              </div>
              <button type="submit" class="btn btn-primary btn-block mt-3 edit-password-submit-button" disabled>ثبت</button>
            </form>
          </div>
        </div>
      </div>
    </div>

    <section class="profile">
      <div class="card mx-auto border-0 profile-panel my-5">
        <div class="card-header border-0">
          <h4 class="text-right">پروفایل شما <a href="#" class="edit-icon mx-2" onclick="activateProfileEdit(event);"><i class="fas fa-pencil-alt"></i></a></h4>
        </div>
        <div class="card-body">
          <form class="text-right" onsubmit="editProfileSubmit(event);">
            <div class="row">
              <div class="col-12">
                <div class="mx-auto position-relative profile-picture-parent">
                  <img src="/images/blank_profile.png" class="rounded-circle">
                  <div class="edit-profile-pic-icon position-absolute rounded-circle d-none">
                    <label for="profile-pic-input" class="d-inline">
                      <i class="fas fa-camera"></i>
                    </label>
                  </div>
                </div>
                <input type="file" name="profile-pic" id="profile-pic-input" class="d-none" onchange="profilePicSelected(event);">
              </div>
              <div class="col-6">
                <div class="form-group">
                  <label for="profileFirstNameInput">نام</label>
                  <input type="text" class="form-control" id="profileFirstNameInput" required disabled value='<%= currentUser.first_name %>' name="first_name">
                </div>
                <div class="form-group">
                  <label for="profileLastNameInput">نام خانوادگی</label>
                  <input type="text" class="form-control" id="profileLastNameInput" required disabled value='<%= currentUser.last_name %>' name="last_name">
                </div>
                <div class="form-group">
                  <label for="profileNumberInput">شماره تماس</label>
                  <input type="number" class="form-control" id="profileNumberInput" required disabled value='<%= currentUser.cell_number %>' name="cell_number">
                </div>
              </div>
              <div class="col-6">
                <div class="form-group">
                  <label for="profileEmailInput">ایمیل (اختیاری)</label>
                  <input type="email" class="form-control" id="profileEmailInput" disabled value='<%= currentUser.email %>' name="email">
                </div>
                <div class="form-group">
                  <label for="profileSocialIdInput">کد ملی (اختیاری)</label>
                  <input type="text" class="form-control" id="profileSocialIdInput" disabled value='<%= currentUser.social_id %>' name="social_id">
                </div>
                <div class="form-group profile-social-id position-relative">
                  <label>عکس کارت ملی (اختیاری)</label>
                  <input type="file" class="d-none" id="social-id-pic-input" onchange="socialIdPicSelected(event);" name="social_id_pic">
                  <% if (currentUser.social_card_img_id == "") { %>
                    <div class="text-center upload-social-id-card d-none">
                      <a href="#" class="btn btn-success"><label for="social-id-pic-input" class="m-0">آپلود کارت ملی</label></a>
                    </div>
                    <div class="edit-social-id-card d-none">
                      <img src="/images/blank_profile.png" class="rounded">
                      <div class="edit-social-id-icon position-absolute d-none">
                        <label for="profile-pic-input" class="d-inline">
                          <i class="fas fa-pencil-alt"></i>
                        </label>
                      </div>
                    </div>
                  <% } else { %>
                  <div class="edit-social-id-card">
                    <img src="/images/blank_profile.png" class="rounded">
                    <div class="edit-social-id-icon position-absolute d-none">
                      <label for="profile-pic-input" class="d-inline">
                        <i class="fas fa-pencil-alt"></i>
                      </label>
                    </div>
                  </div>
                  <% } %>
                </div>
              </div>
            </div>
            <a href="#" class="edit-password-link" data-toggle="modal" data-target="#editPasswordModal">تغییر پسوورد</a>
            <button type="submit" class="btn btn-primary d-none profile-edit-submit-button">ثبت</button>
          </form>
        </div>
      </div>
    </section>

    <%- include("partials/footer") %>

    <script>
      $("#editPasswordModal").on("hide.bs.modal", function (e) {
        $(".new-password-input").val("");
        $(".confirm-new-password-input").val("");
        $(".edit-password-submit-button").attr("disabled", true);
      })

      function activateProfileEdit (e) {
        $(".edit-icon").addClass("d-none");
        $("#profileFirstNameInput").attr("disabled", false);
        $("#profileLastNameInput").attr("disabled", false);
        $("#profileEmailInput").attr("disabled", false);
        $("#profileSocialIdInput").attr("disabled", false);
        $(".profile-edit-submit-button").removeClass("d-none");
        $(".edit-profile-pic-icon").removeClass("d-none");
        // $(".edit-social-id-icon").removeClass("d-none");
        $(".upload-social-id-card").removeClass("d-none");
        $(".edit-password-link").addClass("d-none");

        if (!$(".edit-social-id-card").hasClass("d-none")) {
          $(".edit-social-id-icon").removeClass("d-none");
        }
      }

      function editProfileSubmit (e) {
        e.preventDefault();

        $(".edit-icon").removeClass("d-none");
        $("#profileFirstNameInput").attr("disabled", true);
        $("#profileLastNameInput").attr("disabled", true);
        $("#profileEmailInput").attr("disabled", true);
        $("#profileSocialIdInput").attr("disabled", true);
        $(".profile-edit-submit-button").addClass("d-none");
        $(".edit-profile-pic-icon").addClass("d-none");
        $(".edit-social-id-icon").addClass("d-none");
        $(".upload-social-id-card").addClass("d-none");
        $(".edit-password-link").removeClass("d-none");

        if (!$(".edit-social-id-card").hasClass("d-none")) {
          $(".edit-social-id-icon").addClass("d-none");
        }

        var rawData = {
          first_name: $("input[name='first_name']").val(),
          last_name: $("input[name='last_name']").val(),
          email: $("input[name='email']").val(),
          social_id: $("input[name='social_id']").val()
          // profile_pic: $("input [name='profile-pic']").val(),  //NOT FINISHED
          // social_id_card_pic: $("input [name='social_id']").val()  //NOT FINISHED
        }
        var data = {};
        var rawDataKeys = Object.keys(rawData);
        var dataSaved = `
          <div class="alert alert-success text-right" role="alert">
            اطلاعات با موفقیت ذخیره شد
          </div>
        `;

        console.log(rawData);
        console.log(rawDataKeys);

        for (i = 0; i < rawDataKeys.length; i++) {
          if (rawData[rawDataKeys[i]] != "" && rawData[rawDataKeys[i]] != 0) {
            console.log(rawData[rawDataKeys[i]]);
            data[rawDataKeys[i]] = rawData[rawDataKeys[i]];
          }
        }

        console.log(data);

        $.ajax({
          method: "POST",
          url: "/profile",
          dataType: "json",
          data,

          success: function (data) {
            console.log("PROFILE POST SUCCESSFUL");
            console.log(data);

            $("section.profile .card-body .alert-success").remove();
            $("section.profile .card-body .alert-danger").remove();
            $("section.profile .card-body").prepend(dataSaved);
          },

          error: function (err) {
            console.log("POST REQUEST ERROR");
            console.log(err);
          }
        });
      }

      function confirmPasswordCheck (e) {
        var password, confirmPassword;

        password = $(".new-password-input").val();
        confirmPassword = $(".confirm-new-password-input").val();

        if (password === confirmPassword) {
          $(".edit-password-submit-button").attr("disabled", false);
        } else {
          $(".edit-password-submit-button").attr("disabled", true);
        }
      }

      function clearConfirmPassword (e) {
        $(".confirm-new-password-input").val("");
        $(".edit-password-submit-button").attr("disabled", true);
      }

      function editPassword (e) {
        e.preventDefault();

        console.log("change Password Called");

        var password = $(".new-password-input").val();
        var dataSaved = `
          <div class="alert alert-success text-right" role="alert">
            پسوورد با موفقیت تغییر کرد
          </div>
        `;

        $.ajax({
          method: "POST",
          url: "/edit_password",
          dataType: "json",
          data : {
            password: password
          },

          success: function (data) {
            console.log("PROFILE POST SUCCESSFUL");
            console.log(data);

            $("#editPasswordModal").modal("hide");
            $("section.profile .card-body .alert-success").remove();
            $("section.profile .card-body .alert-danger").remove();
            $("section.profile .card-body").prepend(dataSaved);
          },

          error: function (err) {
            console.log("POST REQUEST ERROR");
            console.log(err);
          }
        });

      }

      function profilePicSelected (e) {
        console.log(e.target);
        console.log(e.target.files);

        var input = e.target;

        if (input.files && input.files[0]) {
          console.log("FILE EXISTS");

          var reader = new FileReader();

          reader.onload = function (e) {
            console.log("IN ON LOAD");
            $(".profile-picture-parent img").attr('src', e.target.result);
          };

          reader.readAsDataURL(input.files[0]);
        }
      }

      function socialIdPicSelected (e) {
        console.log(e.target);
        console.log($(e.target)[0].files);
        console.log($(e.target)[0].files[0].name);

        var input = $(e.target)[0];

        if (input.files && input.files[0]) {
          console.log("FILE EXISTS");

          $(".upload-social-id-card").addClass("d-none");
          $(".edit-social-id-card").removeClass("d-none");
          $(".edit-social-id-icon").removeClass("d-none");

          var reader = new FileReader();

          reader.onload = function (e) {
            console.log("IN ON LOAD");
            $(".edit-social-id-card img").attr('src', e.target.result);
          };

          reader.readAsDataURL(input.files[0]);
        }
      }
    </script>
  </body>
</html>
